<template>
  <div
    v-if="issPositionData && issPositionSunTimeframes"
    class="sidebar mt-10 mb-10 mr-5 text-slate-100 bg-slate-800 p-5 rounded-xl"
  >
    <div>
      <div class="text-2xl mb-5">ISS Tracker</div>
    </div>
    <div class="text-xl mb-1">Position:</div>
    <div>
      <span class="font-bold text-sm">Latitude:</span>
      {{ issPositionData?.latitude }}
    </div>
    <div>
      <span class="font-bold text-sm">Longitude:</span>
      {{ issPositionData?.longitude }}
    </div>
    <div class="flex items-baseline gap-2">
      <span class="font-bold text-sm">Visibility:</span>
      {{ issPositionData?.visibility }}
      <div>
        <span
          v-if="issPositionData.visibility === 'daylight'"
          class="inline-block w-3 h-3 bg-amber-400 rounded-full"
        ></span>
        <span
          v-else-if="issPositionData.visibility === 'eclipsed'"
          class="inline-block w-3 h-3 bg-emerald-700 rounded-full"
        ></span>
      </div>
    </div>
    <div>
      <div class="text-xl mb-1 mt-6">Sun Timeframes:</div>
      <div class="text-sm mb-2" v-for="timeframe in issPositionSunTimeframes">
        <div>
          <span class="font-bold">From:</span>
          {{ timeStampToUtcDate(timeframe.start_time) }}
        </div>
        <div>
          <span class="font-bold">To:</span>
          {{ timeStampToUtcDate(timeframe.end_time) }}
        </div>
      </div>
    </div>
    <div>
      <div>
        <div class="mt-6 flex gap-2">
          <input
            type="text"
            name="pologygons-name"
            class="block rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6"
            placeholder="Polygons name"
            v-model="polygonNameInput"
          />
          <button
            type="button"
            class="rounded bg-indigo-600 px-2 py-1 text-white shadow-sm hover:bg-indigo-500 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-indigo-600"
            @click="onPolygonsSaved"
          >
            Save
          </button>
        </div>
      </div>
    </div>
    <div>
      <div class="mt-6 flex gap-2">
        <select
          id="location"
          name="location"
          class="block w-full rounded-md border-0 py-1.5 pl-3 pr-10 text-gray-900 ring-1 ring-inset ring-gray-300 focus:ring-2 focus:ring-indigo-600 sm:text-sm sm:leading-6"
          v-model="polygonNameSelected"
        >
          <option value="" disabled selected>Select a polygon</option>
          <option v-for="name in geojsonNames" :value="name">{{ name }}</option>
        </select>

        <button
          @click="onPolygonsLoaded"
          type="button"
          class="rounded bg-indigo-600 px-2 py-1 text-white shadow-sm hover:bg-indigo-500 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-indigo-600"
        >
          Load
        </button>
      </div>
    </div>
    <div class="mt-6">
      <button
        @click="manualRefresh"
        type="button"
        class="rounded bg-indigo-600 px-2 py-1 text-white shadow-sm hover:bg-indigo-500 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-indigo-600"
      >
        Manual refresh
      </button>
    </div>
  </div>

  <div v-else class="sidebar mt-10 mr-5">
    <div class="text-2xl mb-3 mt-6">No ISS position data available</div>
  </div>
</template>

<script setup lang="ts">
const { issPositionData, issPositionRefresh } = await useIssPosition();
const { issPositionSunTimeframes, issPositionSunTimeframesRefresh } =
  await useIssSunTimeFrame();

const { data: geojsonNames, refresh: geojsonNamesRefresh } = await useFetch<
  string[]
>("http://127.0.0.1:3001/geojson/name");

const savedGeojson = useSavedGeojson();
const appConfig = useAppConfig();

const polygonNameInput = ref("");
const polygonNameSelected = ref("");

const timeStampToUtcDate = (timeStamp: number) =>
  new Intl.DateTimeFormat("en-US", {
    timeZone: "UTC",
    dateStyle: "medium",
    timeStyle: "medium",
  }).format(timeStamp * 1000);

onMounted(() => {
  setInterval(() => {
    issPositionSunTimeframesRefresh();
  }, appConfig.refreshInterval);
});

const manualRefresh = () => {
  issPositionSunTimeframesRefresh();
  issPositionRefresh();
};

const onPolygonsSaved = async () => {
  if (polygonNameInput.value && savedGeojson.value) {
    await postGeojson(polygonNameInput.value, savedGeojson.value);
    await geojsonNamesRefresh();
    polygonNameInput.value = "";
  }
};

const onPolygonsLoaded = async () => {
  await useRetrievedGeojson(polygonNameSelected.value);
};
</script>

<style scoped>
.sidebar {
  min-width: 250px;
}
</style>
